# Class MetalScrollBarUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.ScrollBarUI
javax.swing.plaf.basic.BasicScrollBarUI
javax.swing.plaf.metal.MetalScrollBarUI

All Implemented Interfaces:
  `LayoutManager, SwingConstants`

public class MetalScrollBarUI extends BasicScrollBarUI
Implementation of ScrollBarUI for the Metal Look and Feel

## Nested Class Summary

### Nested classes/interfaces declared in class BasicScrollBarUI

`BasicScrollBarUI.ArrowButtonListener, BasicScrollBarUI.ModelListener, BasicScrollBarUI.PropertyChangeHandler, BasicScrollBarUI.ScrollListener, BasicScrollBarUI.TrackListener`
Modifier and Type
Class
Description
`protected class`
`BasicScrollBarUI.ArrowButtonListener`
Listener for cursor keys.
`protected class`
`BasicScrollBarUI.ModelListener`
A listener to listen for model changes.
`class`
`BasicScrollBarUI.PropertyChangeHandler`
Property change handler
`protected class`
`BasicScrollBarUI.ScrollListener`
Listener for scrolling events initiated in the `ScrollPane`.
`protected class`
`BasicScrollBarUI.TrackListener`
Track mouse drags.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected MetalScrollButton`
`decreaseButton`
The decrease button.
`static final String`
`FREE_STANDING_PROP`
The property `JScrollBar.isFreeStanding`.
`protected MetalScrollButton`
`increaseButton`
The increase button.
`protected boolean`
`isFreeStanding`
The value of the property `JScrollBar.isFreeStanding`.
`protected int`
`scrollBarWidth`
The width of the scroll bar.

### Fields declared in class BasicScrollBarUI

`buttonListener, decrButton, DECREASE_HIGHLIGHT, decrGap, incrButton, INCREASE_HIGHLIGHT, incrGap, isDragging, maximumThumbSize, minimumThumbSize, modelListener, NO_HIGHLIGHT, propertyChangeListener, scrollbar, scrollListener, scrollTimer, thumbDarkShadowColor, thumbLightShadowColor, thumbRect, trackColor, trackHighlight, trackHighlightColor, trackListener, trackRect`
Modifier and Type
Field
Description
`protected BasicScrollBarUI.ArrowButtonListener`
`buttonListener`
Button listener
`protected JButton`
`decrButton`
Decrement button
`protected static final int`
`DECREASE_HIGHLIGHT`
Decrease highlight
`protected int`
`decrGap`
Distance between the decrement button and the track.
`protected JButton`
`incrButton`
Increment button
`protected static final int`
`INCREASE_HIGHLIGHT`
Increase highlight
`protected int`
`incrGap`
Distance between the increment button and the track.
`protected boolean`
`isDragging`
Dragging
`protected Dimension`
`maximumThumbSize`
Maximum thumb size
`protected Dimension`
`minimumThumbSize`
Minimum thumb size
`protected BasicScrollBarUI.ModelListener`
`modelListener`
Model listener
`protected static final int`
`NO_HIGHLIGHT`
No highlight
`protected PropertyChangeListener`
`propertyChangeListener`
Property change listener
`protected JScrollBar`
`scrollbar`
Scrollbar
`protected BasicScrollBarUI.ScrollListener`
`scrollListener`
Scroll listener
`protected Timer`
`scrollTimer`
Scroll timer
`protected Color`
`thumbDarkShadowColor`
Thumb dark shadow color
`protected Color`
`thumbLightShadowColor`
Thumb light shadow color
`protected Rectangle`
`thumbRect`
Thumb rectangle
`protected Color`
`trackColor`
Track color
`protected int`
`trackHighlight`
Track highlight
`protected Color`
`trackHighlightColor`
Track highlight color
`protected BasicScrollBarUI.TrackListener`
`trackListener`
Track listener
`protected Rectangle`
`trackRect`
Track rectangle

### Fields declared in interface SwingConstants

`BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
Modifier and Type
Field
Description
`static final int`
`BOTTOM`
Box-orientation constant used to specify the bottom of a box.
`static final int`
`CENTER`
The central position in an area.
`static final int`
`EAST`
Compass-direction east (right).
`static final int`
`HORIZONTAL`
Horizontal orientation.
`static final int`
`LEADING`
Identifies the leading edge of text for use with left-to-right and right-to-left languages.
`static final int`
`LEFT`
Box-orientation constant used to specify the left side of a box.
`static final int`
`NEXT`
Identifies the next direction in a sequence.
`static final int`
`NORTH`
Compass-direction North (up).
`static final int`
`NORTH_EAST`
Compass-direction north-east (upper right).
`static final int`
`NORTH_WEST`
Compass-direction north west (upper left).
`static final int`
`PREVIOUS`
Identifies the previous direction in a sequence.
`static final int`
`RIGHT`
Box-orientation constant used to specify the right side of a box.
`static final int`
`SOUTH`
Compass-direction south (down).
`static final int`
`SOUTH_EAST`
Compass-direction south-east (lower right).
`static final int`
`SOUTH_WEST`
Compass-direction south-west (lower left).
`static final int`
`TOP`
Box-orientation constant used to specify the top of a box.
`static final int`
`TRAILING`
Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
`static final int`
`VERTICAL`
Vertical orientation.
`static final int`
`WEST`
Compass-direction west (left).

## Constructor Summary

Constructors
Constructor
Description
`MetalScrollBarUI()`
Constructs a `MetalScrollBarUI`.

## Method Summary

Modifier and Type
Method
Description
`protected JButton`
`createDecreaseButton(int orientation)`
Returns the view that represents the decrease view.
`protected JButton`
`createIncreaseButton(int orientation)`
Returns the view that represents the increase view.
`static ComponentUI`
`createUI(JComponent c)`
Constructs a new `MetalScrollBarUI` instance.
`protected void`
`setThumbBounds(int x, int y, int width, int height)`
This is overridden only to increase the invalid area.

### Methods declared in class BasicScrollBarUI

`addLayoutComponent, configureScrollBarColors, createArrowButtonListener, createModelListener, createPropertyChangeListener, createScrollListener, createTrackListener, getMaximumSize, getMaximumThumbSize, getMinimumThumbSize, getPreferredSize, getSupportsAbsolutePositioning, getThumbBounds, getTrackBounds, installComponents, installDefaults, installKeyboardActions, installListeners, installUI, isThumbRollover, layoutContainer, layoutHScrollbar, layoutVScrollbar, minimumLayoutSize, paintDecreaseHighlight, paintIncreaseHighlight, paintThumb, paintTrack, preferredLayoutSize, removeLayoutComponent, scrollByBlock, scrollByUnit, setThumbRollover, uninstallComponents, uninstallDefaults, uninstallKeyboardActions, uninstallListeners, uninstallUI`
Modifier and Type
Method
Description
`void`
`addLayoutComponent(String name, Component child)`
If the layout manager uses a per-component string, adds the component `comp` to the layout, associating it with the string specified by `name`.
`protected void`
`configureScrollBarColors()`
Configures the scroll bar colors.
`protected BasicScrollBarUI.ArrowButtonListener`
`createArrowButtonListener()`
Creates an arrow button listener.
`protected BasicScrollBarUI.ModelListener`
`createModelListener()`
Creates a model listener.
`protected PropertyChangeListener`
`createPropertyChangeListener()`
Creates a property change listener.
`protected BasicScrollBarUI.ScrollListener`
`createScrollListener()`
Creates a scroll listener.
`protected BasicScrollBarUI.TrackListener`
`createTrackListener()`
Creates a track listener.
`Dimension`
`getMaximumSize(JComponent c)`
Returns the specified component's maximum size appropriate for the look and feel.
`protected Dimension`
`getMaximumThumbSize()`
Returns the largest acceptable size for the thumb.
`protected Dimension`
`getMinimumThumbSize()`
Returns the smallest acceptable size for the thumb.
`Dimension`
`getPreferredSize(JComponent c)`
A vertical scrollbar's preferred width is the maximum of preferred widths of the (non `null`) increment/decrement buttons, and the minimum width of the thumb.
`boolean`
`getSupportsAbsolutePositioning()`
Indicates whether the user can absolutely position the thumb with a mouse gesture (usually the middle mouse button).
`protected Rectangle`
`getThumbBounds()`
Return the current size/location of the thumb.
`protected Rectangle`
`getTrackBounds()`
Returns the current bounds of the track, i.e. the space in between the increment and decrement buttons, less the insets.
`protected void`
`installComponents()`
Installs the components.
`protected void`
`installDefaults()`
Installs the defaults.
`protected void`
`installKeyboardActions()`
Installs the keyboard actions.
`protected void`
`installListeners()`
Installs the listeners.
`void`
`installUI(JComponent c)`
Installs the UI.
`boolean`
`isThumbRollover()`
Returns true if the mouse is currently over the thumb.
`void`
`layoutContainer(Container scrollbarContainer)`
Lays out the specified container.
`protected void`
`layoutHScrollbar(JScrollBar sb)`
Lays out a horizontal scroll bar.
`protected void`
`layoutVScrollbar(JScrollBar sb)`
Lays out a vertical scroll bar.
`Dimension`
`minimumLayoutSize(Container scrollbarContainer)`
Calculates the minimum size dimensions for the specified container, given the components it contains.
`protected void`
`paintDecreaseHighlight(Graphics g)`
Paints the decrease highlight.
`protected void`
`paintIncreaseHighlight(Graphics g)`
Paints the increase highlight.
`protected void`
`paintThumb(Graphics g, JComponent c, Rectangle thumbBounds)`
Paints the thumb.
`protected void`
`paintTrack(Graphics g, JComponent c, Rectangle trackBounds)`
Paints the track.
`Dimension`
`preferredLayoutSize(Container scrollbarContainer)`
Calculates the preferred size dimensions for the specified container, given the components it contains.
`void`
`removeLayoutComponent(Component child)`
Removes the specified component from the layout.
`protected void`
`scrollByBlock(int direction)`
Scrolls by block.
`protected void`
`scrollByUnit(int direction)`
Scrolls by unit.
`protected void`
`setThumbRollover(boolean active)`
Sets whether or not the mouse is currently over the thumb.
`protected void`
`uninstallComponents()`
Uninstalls the components.
`protected void`
`uninstallDefaults()`
Uninstalls the defaults.
`protected void`
`uninstallKeyboardActions()`
Uninstalls the keyboard actions.
`protected void`
`uninstallListeners()`
Uninstall the listeners.
`void`
`uninstallUI(JComponent c)`
Uninstalls the UI.

### Methods declared in class ComponentUI

`contains, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMinimumSize, paint, update`
Modifier and Type
Method
Description
`boolean`
`contains(JComponent c, int x, int y)`
Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
`Accessible`
`getAccessibleChild(JComponent c, int i)`
Returns the `i`th `Accessible` child of the object.
`int`
`getAccessibleChildrenCount(JComponent c)`
Returns the number of accessible children in the object.
`int`
`getBaseline(JComponent c, int width, int height)`
Returns the baseline.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior(JComponent c)`
Returns an enum indicating how the baseline of the component changes as the size changes.
`Dimension`
`getMinimumSize(JComponent c)`
Returns the specified component's minimum size appropriate for the look and feel.
`void`
`paint(Graphics g, JComponent c)`
Paints the specified component appropriately for the look and feel.
`void`
`update(Graphics g, JComponent c)`
Notifies this UI delegate that it is time to paint the specified component.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### increaseButton

protected MetalScrollButton increaseButton
The increase button.

### decreaseButton

protected MetalScrollButton decreaseButton
The decrease button.

### scrollBarWidth

protected int scrollBarWidth
The width of the scroll bar.

### FREE_STANDING_PROP

public static final String FREE_STANDING_PROP
The property `JScrollBar.isFreeStanding`.

See Also:
  - Constant Field Values

### isFreeStanding

protected boolean isFreeStanding
The value of the property `JScrollBar.isFreeStanding`.

## Constructor Details

### MetalScrollBarUI

public MetalScrollBarUI()
Constructs a `MetalScrollBarUI`.

## Method Details

### createUI

public static ComponentUI createUI(JComponent c)
Constructs a new `MetalScrollBarUI` instance.

Parameters:
  `c` - a component
Returns:
  a new `MetalScrollBarUI` instance

### createDecreaseButton

protected JButton createDecreaseButton(int orientation)
Returns the view that represents the decrease view.

Overrides:
  `createDecreaseButton` in class `BasicScrollBarUI`
Parameters:
  `orientation` - the orientation
Returns:
  a decrease button

### createIncreaseButton

protected JButton createIncreaseButton(int orientation)
Returns the view that represents the increase view.

Overrides:
  `createIncreaseButton` in class `BasicScrollBarUI`
Parameters:
  `orientation` - the orientation
Returns:
  an increase button

### setThumbBounds

protected void setThumbBounds(int x, int y, int width, int height)
This is overridden only to increase the invalid area. This ensures that the "Shadow" below the thumb is invalidated

Overrides:
  `setThumbBounds` in class `BasicScrollBarUI`
Parameters:
  `x` - set the x location of the thumb
  `y` - set the y location of the thumb
  `width` - set the width of the thumb
  `height` - set the height of the thumb
See Also:
  - `BasicScrollBarUI.getThumbBounds()`